/*;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;		AVR t2313 TestProgramm
;
;
;		CPU	ATtiny2313-20PU
;			CLK=INT CRosc(8MHz)  CLKDIV=1/1
;			FuseE="FF" FuseH="DF" FuseL="E4" 
;
;			
;		2012-06-19		c[H[Ec
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;*/


#include <avr/io.h>



volatile static unsigned int	TIME;

volatile static unsigned char	HEXH,HEXL;






void TX(unsigned char TXD){

	while(!(UCSRA & (1<<UDRE)));
	UDR = TXD;

}



void Wait(void){					/* 1mS Timer */
	volatile int i;
	volatile unsigned char	rx;


	for(i=0; i<348; i++){
		if ((UCSRA & 0x80) != 0){
			rx = UDR;
			TX(rx);					//echo
		}
	}

}



void Timer(int Time){			/* mS Timer */
	volatile int i;

	for(i=0; i<Time; i++){
		Wait();
	}

}



unsigned char hex(unsigned char bin){

	bin &= 0x0f;					//O`PT
	if (bin < 10){
		bin = bin | 0x30;
	}
	else{
		bin = bin + 0x37;
	}

	return bin;
}



void bin_hex(unsigned char bin){	//Binary  2Hex(HEXH,HEXL)

	unsigned char hi,lo;

	hi = bin / 16;
	HEXH = hex(hi);
	lo = bin % 16;
	HEXL = hex(lo);
}



void TX_int(unsigned int DATA){
		bin_hex(DATA / 256);
		TX(HEXH);
		TX(HEXL);
		bin_hex(DATA & 0x00ff);
		TX(HEXH);
		TX(HEXL);
		TX(0x20);
}








void Init(void){			/*Initialize*/

	DDRA = 0x07;			//portA output
	PORTA = 0x00;
	DDRB = 0xff;			//portB output
	PORTB = 0x00;
	DDRD = 0x7f;			//portD output
	PORTD = 0x00;

	UBRRH = 0;				/*baud rate 9600*/
	UBRRL = 51;				/*fosc/(16*baudrate) -1*/
	UCSRC = 0x0e;			/*S8N2*/
	UCSRB = 0x18;			/*TX & RX enable*/


	Timer(50);

	TIME = 0;

}





int main(){

//	volatile int	i;
//	volatile unsigned char	d;
	volatile int i;


	Init();

while(1){


	for(i=0; i<3; i++){

		Timer(2000);
		PORTA = 0xff;
		PORTB = 0xff;
		PORTD = 0xff;

		Timer(1000);
		PORTA = 0x00;
		PORTB = 0x00;
		PORTD = 0x00;

	}



	for(i=0; i<15; i++){

		Timer(200);
		PORTA = 0x55;
		PORTB = 0x55;
		PORTD = 0xaa;

		Timer(200);
		PORTA = 0xaa;
		PORTB = 0xaa;
		PORTD = 0x55;

		TX_int(i);

	}

}


}

